/* Generated by wayland-scanner 1.18.0 */

/*
 * Copyright (C) 2017 Advanced Driver Information Technology Joint Venture GmbH
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

extern const struct wl_interface ivi_screenshot_interface;
extern const struct wl_interface ivi_wm_screen_interface;
extern const struct wl_interface wl_output_interface;

static const struct wl_interface *ivi_wm_types[] = {
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	&ivi_screenshot_interface,
	&wl_output_interface,
	&ivi_wm_screen_interface,
	&ivi_screenshot_interface,
	NULL,
};

static const struct wl_message ivi_wm_screen_requests[] = {
	{ "destroy", "", ivi_wm_types + 0 },
	{ "clear", "", ivi_wm_types + 0 },
	{ "add_layer", "u", ivi_wm_types + 0 },
	{ "remove_layer", "u", ivi_wm_types + 0 },
	{ "screenshot", "n", ivi_wm_types + 6 },
	{ "get", "i", ivi_wm_types + 0 },
};

static const struct wl_message ivi_wm_screen_events[] = {
	{ "screen_id", "u", ivi_wm_types + 0 },
	{ "layer_added", "u", ivi_wm_types + 0 },
	{ "connector_name", "s", ivi_wm_types + 0 },
	{ "error", "us", ivi_wm_types + 0 },
};

WL_EXPORT const struct wl_interface ivi_wm_screen_interface = {
	"ivi_wm_screen", 1,
	6, ivi_wm_screen_requests,
	4, ivi_wm_screen_events,
};

static const struct wl_message ivi_screenshot_events[] = {
	{ "done", "hiiiuu", ivi_wm_types + 0 },
	{ "error", "us", ivi_wm_types + 0 },
};

WL_EXPORT const struct wl_interface ivi_screenshot_interface = {
	"ivi_screenshot", 1,
	0, NULL,
	2, ivi_screenshot_events,
};

static const struct wl_message ivi_wm_requests[] = {
	{ "commit_changes", "", ivi_wm_types + 0 },
	{ "create_screen", "on", ivi_wm_types + 7 },
	{ "set_surface_visibility", "uu", ivi_wm_types + 0 },
	{ "set_layer_visibility", "uu", ivi_wm_types + 0 },
	{ "set_surface_opacity", "uf", ivi_wm_types + 0 },
	{ "set_layer_opacity", "uf", ivi_wm_types + 0 },
	{ "set_surface_source_rectangle", "uiiii", ivi_wm_types + 0 },
	{ "set_layer_source_rectangle", "uiiii", ivi_wm_types + 0 },
	{ "set_surface_destination_rectangle", "uiiii", ivi_wm_types + 0 },
	{ "set_layer_destination_rectangle", "uiiii", ivi_wm_types + 0 },
	{ "surface_sync", "ui", ivi_wm_types + 0 },
	{ "layer_sync", "ui", ivi_wm_types + 0 },
	{ "surface_get", "ui", ivi_wm_types + 0 },
	{ "layer_get", "ui", ivi_wm_types + 0 },
	{ "surface_screenshot", "nu", ivi_wm_types + 9 },
	{ "set_surface_type", "ui", ivi_wm_types + 0 },
	{ "layer_clear", "u", ivi_wm_types + 0 },
	{ "layer_add_surface", "uu", ivi_wm_types + 0 },
	{ "layer_remove_surface", "uu", ivi_wm_types + 0 },
	{ "create_layout_layer", "uii", ivi_wm_types + 0 },
	{ "destroy_layout_layer", "u", ivi_wm_types + 0 },
};

static const struct wl_message ivi_wm_events[] = {
	{ "surface_visibility", "ui", ivi_wm_types + 0 },
	{ "layer_visibility", "ui", ivi_wm_types + 0 },
	{ "surface_opacity", "uf", ivi_wm_types + 0 },
	{ "layer_opacity", "uf", ivi_wm_types + 0 },
	{ "surface_source_rectangle", "uiiii", ivi_wm_types + 0 },
	{ "layer_source_rectangle", "uiiii", ivi_wm_types + 0 },
	{ "surface_destination_rectangle", "uiiii", ivi_wm_types + 0 },
	{ "layer_destination_rectangle", "uiiii", ivi_wm_types + 0 },
	{ "surface_created", "u", ivi_wm_types + 0 },
	{ "layer_created", "u", ivi_wm_types + 0 },
	{ "surface_destroyed", "u", ivi_wm_types + 0 },
	{ "layer_destroyed", "u", ivi_wm_types + 0 },
	{ "surface_error", "uus", ivi_wm_types + 0 },
	{ "layer_error", "uus", ivi_wm_types + 0 },
	{ "surface_size", "uii", ivi_wm_types + 0 },
	{ "surface_stats", "uuu", ivi_wm_types + 0 },
	{ "layer_surface_added", "uu", ivi_wm_types + 0 },
};

WL_EXPORT const struct wl_interface ivi_wm_interface = {
	"ivi_wm", 1,
	21, ivi_wm_requests,
	17, ivi_wm_events,
};

