/* Generated by wayland-scanner 1.18.0 */

#ifndef IVI_WM_SERVER_PROTOCOL_H
#define IVI_WM_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_ivi_wm The ivi_wm protocol
 * @section page_ifaces_ivi_wm Interfaces
 * - @subpage page_iface_ivi_wm_screen - controller interface to screen in ivi compositor
 * - @subpage page_iface_ivi_screenshot - screenshot of an output or a surface
 * - @subpage page_iface_ivi_wm - interface for ivi managers to use ivi compositor features
 * @section page_copyright_ivi_wm Copyright
 * <pre>
 *
 * Copyright (C) 2017 Advanced Driver Information Technology Joint Venture GmbH
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * </pre>
 */
struct ivi_screenshot;
struct ivi_wm;
struct ivi_wm_screen;
struct wl_output;

/**
 * @page page_iface_ivi_wm_screen ivi_wm_screen
 * @section page_iface_ivi_wm_screen_desc Description
 * @section page_iface_ivi_wm_screen_api API
 * See @ref iface_ivi_wm_screen.
 */
/**
 * @defgroup iface_ivi_wm_screen The ivi_wm_screen interface
 */
extern const struct wl_interface ivi_wm_screen_interface;
/**
 * @page page_iface_ivi_screenshot ivi_screenshot
 * @section page_iface_ivi_screenshot_desc Description
 *
 * An ivi_screenshot object receives a single "done" or "error" event.
 * The server will destroy this resource after the event has been send,
 * so the client shall then destroy its proxy too.
 * @section page_iface_ivi_screenshot_api API
 * See @ref iface_ivi_screenshot.
 */
/**
 * @defgroup iface_ivi_screenshot The ivi_screenshot interface
 *
 * An ivi_screenshot object receives a single "done" or "error" event.
 * The server will destroy this resource after the event has been send,
 * so the client shall then destroy its proxy too.
 */
extern const struct wl_interface ivi_screenshot_interface;
/**
 * @page page_iface_ivi_wm ivi_wm
 * @section page_iface_ivi_wm_desc Description
 * @section page_iface_ivi_wm_api API
 * See @ref iface_ivi_wm.
 */
/**
 * @defgroup iface_ivi_wm The ivi_wm interface
 */
extern const struct wl_interface ivi_wm_interface;

#ifndef IVI_WM_SCREEN_ERROR_ENUM
#define IVI_WM_SCREEN_ERROR_ENUM
enum ivi_wm_screen_error {
	/**
	 * the layer with given id does not exist
	 */
	IVI_WM_SCREEN_ERROR_NO_LAYER = 0,
	/**
	 * the output is already destroyed
	 */
	IVI_WM_SCREEN_ERROR_NO_SCREEN = 1,
	/**
	 * the given parameter is not valid
	 */
	IVI_WM_SCREEN_ERROR_BAD_PARAM = 2,
};
#endif /* IVI_WM_SCREEN_ERROR_ENUM */

/**
 * @ingroup iface_ivi_wm_screen
 * @struct ivi_wm_screen_interface
 */
struct ivi_wm_screen_interface {
	/**
	 * destroy ivi_wm_screen
	 *
	 * Request to destroy the ivi_wm_screen.
	 */
	void (*destroy)(struct wl_client *client,
			struct wl_resource *resource);
	/**
	 * remove all layers from screen render order
	 *
	 * A screen has no content assigned to itself, it is a container
	 * for layers. This request removes all layers from the screen
	 * render order. Note: the layers are not destroyed, they are just
	 * no longer contained by the screen.
	 */
	void (*clear)(struct wl_client *client,
		      struct wl_resource *resource);
	/**
	 * add a layer to screen render order at nearest z-position
	 *
	 * A screen has no content assigned to itself, it is a container
	 * for layers. This request adds a layers to the topmost position
	 * of the screen render order. The added layer will cover all other
	 * layers of the screen.
	 */
	void (*add_layer)(struct wl_client *client,
			  struct wl_resource *resource,
			  uint32_t layer_id);
	/**
	 * remove a layer to screen render order
	 *
	 * A screen has no content assigned to itself, it is a container
	 * for layers. This request removes a layer.
	 */
	void (*remove_layer)(struct wl_client *client,
			     struct wl_resource *resource,
			     uint32_t layer_id);
	/**
	 * take screenshot of screen
	 *
	 * An ivi_screenshot object is created which will receive the
	 * screenshot data of the specified output.
	 */
	void (*screenshot)(struct wl_client *client,
			   struct wl_resource *resource,
			   uint32_t screenshot);
	/**
	 * get a parameter of a screen in ivi compositor
	 *
	 * After this request, compositor sends the requested parameter.
	 */
	void (*get)(struct wl_client *client,
		    struct wl_resource *resource,
		    int32_t param);
};

#define IVI_WM_SCREEN_SCREEN_ID 0
#define IVI_WM_SCREEN_LAYER_ADDED 1
#define IVI_WM_SCREEN_CONNECTOR_NAME 2
#define IVI_WM_SCREEN_ERROR 3

/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_SCREEN_ID_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_LAYER_ADDED_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_CONNECTOR_NAME_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_ERROR_SINCE_VERSION 1

/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_CLEAR_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_ADD_LAYER_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_REMOVE_LAYER_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_SCREENSHOT_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm_screen
 */
#define IVI_WM_SCREEN_GET_SINCE_VERSION 1

/**
 * @ingroup iface_ivi_wm_screen
 * Sends an screen_id event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_screen_send_screen_id(struct wl_resource *resource_, uint32_t id)
{
	wl_resource_post_event(resource_, IVI_WM_SCREEN_SCREEN_ID, id);
}

/**
 * @ingroup iface_ivi_wm_screen
 * Sends an layer_added event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_screen_send_layer_added(struct wl_resource *resource_, uint32_t layer_id)
{
	wl_resource_post_event(resource_, IVI_WM_SCREEN_LAYER_ADDED, layer_id);
}

/**
 * @ingroup iface_ivi_wm_screen
 * Sends an connector_name event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_screen_send_connector_name(struct wl_resource *resource_, const char *process_name)
{
	wl_resource_post_event(resource_, IVI_WM_SCREEN_CONNECTOR_NAME, process_name);
}

/**
 * @ingroup iface_ivi_wm_screen
 * Sends an error event to the client owning the resource.
 * @param resource_ The client's resource
 * @param error error code
 * @param message error description
 */
static inline void
ivi_wm_screen_send_error(struct wl_resource *resource_, uint32_t error, const char *message)
{
	wl_resource_post_event(resource_, IVI_WM_SCREEN_ERROR, error, message);
}

#ifndef IVI_SCREENSHOT_ERROR_ENUM
#define IVI_SCREENSHOT_ERROR_ENUM
enum ivi_screenshot_error {
	/**
	 * screenshot file could not be created
	 */
	IVI_SCREENSHOT_ERROR_IO_ERROR = 0,
	/**
	 * screenshot can not be read
	 */
	IVI_SCREENSHOT_ERROR_NOT_SUPPORTED = 1,
	/**
	 * output has been destroyed
	 */
	IVI_SCREENSHOT_ERROR_NO_OUTPUT = 2,
	/**
	 * surface has been destroyed
	 */
	IVI_SCREENSHOT_ERROR_NO_SURFACE = 3,
	/**
	 * surface has no content
	 */
	IVI_SCREENSHOT_ERROR_NO_CONTENT = 4,
};
#endif /* IVI_SCREENSHOT_ERROR_ENUM */

#define IVI_SCREENSHOT_DONE 0
#define IVI_SCREENSHOT_ERROR 1

/**
 * @ingroup iface_ivi_screenshot
 */
#define IVI_SCREENSHOT_DONE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_screenshot
 */
#define IVI_SCREENSHOT_ERROR_SINCE_VERSION 1


/**
 * @ingroup iface_ivi_screenshot
 * Sends an done event to the client owning the resource.
 * @param resource_ The client's resource
 * @param fd fd for file containing image data
 * @param width image width in pixels
 * @param height image height in pixels
 * @param stride number of bytes per pixel row
 * @param format image format of type wl_shm.format
 * @param timestamp timestamp in milliseconds
 */
static inline void
ivi_screenshot_send_done(struct wl_resource *resource_, int32_t fd, int32_t width, int32_t height, int32_t stride, uint32_t format, uint32_t timestamp)
{
	wl_resource_post_event(resource_, IVI_SCREENSHOT_DONE, fd, width, height, stride, format, timestamp);
}

/**
 * @ingroup iface_ivi_screenshot
 * Sends an error event to the client owning the resource.
 * @param resource_ The client's resource
 * @param error error code
 * @param message error description
 */
static inline void
ivi_screenshot_send_error(struct wl_resource *resource_, uint32_t error, const char *message)
{
	wl_resource_post_event(resource_, IVI_SCREENSHOT_ERROR, error, message);
}

#ifndef IVI_WM_SYNC_ENUM
#define IVI_WM_SYNC_ENUM
/**
 * @ingroup iface_ivi_wm
 * sync request states
 *
 */
enum ivi_wm_sync {
	IVI_WM_SYNC_ADD = 0,
	IVI_WM_SYNC_REMOVE = 1,
};
#endif /* IVI_WM_SYNC_ENUM */

#ifndef IVI_WM_PARAM_ENUM
#define IVI_WM_PARAM_ENUM
/**
 * @ingroup iface_ivi_wm
 * parameter types
 *
 * The HMI controller can request different types of parameters of an
 * ivi-object.
 */
enum ivi_wm_param {
	IVI_WM_PARAM_OPACITY = 1,
	IVI_WM_PARAM_VISIBILITY = 2,
	IVI_WM_PARAM_SIZE = 4,
	IVI_WM_PARAM_RENDER_ORDER = 8,
};
#endif /* IVI_WM_PARAM_ENUM */

#ifndef IVI_WM_SURFACE_TYPE_ENUM
#define IVI_WM_SURFACE_TYPE_ENUM
/**
 * @ingroup iface_ivi_wm
 * hint for the compositor
 *
 * If a surface is restricted type, visible contents of the surface is strictly
 * controlled by the compositor. Its content is not allowed to be go out of
 * its destination region. If the application resizes its buffers or uses
 * wp_viewporter protocol to scale its contents, the old destination region
 * would causes visible glitches.
 * To avoid these issues, the controller process mark a surface as desktop
 * compatible. Source and destination regions of a desktop compatible
 * surface will be modified accordingly,when application sends a request
 * for resizing or scaling its contents. Therefore, applications contents
 * will be drawn according to application's wishes.
 * On the other hand, source and destination regions will be strictly
 * enforced, when the surface's type is restricted. The default type for
 * a surface is ivi.
 */
enum ivi_wm_surface_type {
	/**
	 * strictly controlled
	 */
	IVI_WM_SURFACE_TYPE_RESTRICTED = 0,
	/**
	 * free to resize and scale
	 */
	IVI_WM_SURFACE_TYPE_DESKTOP = 1,
};
#endif /* IVI_WM_SURFACE_TYPE_ENUM */

#ifndef IVI_WM_SURFACE_ERROR_ENUM
#define IVI_WM_SURFACE_ERROR_ENUM
enum ivi_wm_surface_error {
	/**
	 * the surface with given id does not exist
	 */
	IVI_WM_SURFACE_ERROR_NO_SURFACE = 0,
	/**
	 * the given parameter is not valid
	 */
	IVI_WM_SURFACE_ERROR_BAD_PARAM = 1,
	/**
	 * the request is not supported
	 */
	IVI_WM_SURFACE_ERROR_NOT_SUPPORTED = 2,
};
#endif /* IVI_WM_SURFACE_ERROR_ENUM */

#ifndef IVI_WM_LAYER_ERROR_ENUM
#define IVI_WM_LAYER_ERROR_ENUM
enum ivi_wm_layer_error {
	/**
	 * the surface with given id does not exist
	 */
	IVI_WM_LAYER_ERROR_NO_SURFACE = 0,
	/**
	 * the layer with given id does not exist
	 */
	IVI_WM_LAYER_ERROR_NO_LAYER = 1,
	/**
	 * the given parameter is not valid
	 */
	IVI_WM_LAYER_ERROR_BAD_PARAM = 2,
};
#endif /* IVI_WM_LAYER_ERROR_ENUM */

/**
 * @ingroup iface_ivi_wm
 * @struct ivi_wm_interface
 */
struct ivi_wm_interface {
	/**
	 * commit all changes requested by client
	 *
	 * All requests are not applied directly to scene object, so a
	 * controller can set different properties and apply the changes
	 * all at once. Note: there's an exception to this. Creation and
	 * destruction of scene objects is executed immediately.
	 */
	void (*commit_changes)(struct wl_client *client,
			       struct wl_resource *resource);
	/**
	 * create a screen in ivi-compositor
	 *
	 * Ask the ivi-wm to create a ivi-screen for given wl_output.
	 * @param id the new ivi-screen
	 */
	void (*create_screen)(struct wl_client *client,
			      struct wl_resource *resource,
			      struct wl_resource *output,
			      uint32_t id);
	/**
	 * set the visibility of a surface in ivi compositor
	 *
	 * If visibility argument is 0, the surface in the ivi compositor
	 * is set to invisible. If visibility argument is not 0, the
	 * surface in the ivi compositor is set to visible.
	 */
	void (*set_surface_visibility)(struct wl_client *client,
				       struct wl_resource *resource,
				       uint32_t surface_id,
				       uint32_t visibility);
	/**
	 * set visibility of layer in ivi compositor
	 *
	 * If visibility argument is 0, the layer in the ivi compositor
	 * is set to invisible. If visibility argument is not 0, the layer
	 * in the ivi compositor is set to visible.
	 */
	void (*set_layer_visibility)(struct wl_client *client,
				     struct wl_resource *resource,
				     uint32_t layer_id,
				     uint32_t visibility);
	/**
	 * set the opacity of a surface in ivi compositor
	 *
	 * The valid range for opacity is 0.0 (fully transparent) to 1.0
	 * (fully opaque).
	 */
	void (*set_surface_opacity)(struct wl_client *client,
				    struct wl_resource *resource,
				    uint32_t surface_id,
				    wl_fixed_t opacity);
	/**
	 * set opacity of layer in ivi compositor
	 *
	 * The valid range for opacity is 0.0 (fully transparent) to 1.0
	 * (fully opaque).
	 */
	void (*set_layer_opacity)(struct wl_client *client,
				  struct wl_resource *resource,
				  uint32_t layer_id,
				  wl_fixed_t opacity);
	/**
	 * set the scanout area of a surface in ivi compositor
	 *
	 * The source rectangle defines the part of the surface content,
	 * that is used for compositing the surface. It can be used, if
	 * valid content of the surface is smaller than the surface.
	 * Effectively it can be used to zoom the content of the surface.
	 * If a parameter is less than 0, that value is not changed. x:
	 * horizontal start position of scanout area within the surface y:
	 * vertical start position of scanout area within the surface
	 * width: width of scanout area within the surface height: height
	 * of scanout area within the surface
	 */
	void (*set_surface_source_rectangle)(struct wl_client *client,
					     struct wl_resource *resource,
					     uint32_t surface_id,
					     int32_t x,
					     int32_t y,
					     int32_t width,
					     int32_t height);
	/**
	 * set the scanout area of a layer in ivi compositor
	 *
	 * The source rectangle defines the part of the layer content,
	 * that is used for compositing the screen. It can be used, if
	 * valid content of the layer is smaller than the layer.
	 * Effectively it can be used to zoom the content of the layer. If
	 * a parameter is less than 0, that value is not changed. x:
	 * horizontal start position of scanout area within the layer y:
	 * vertical start position of scanout area within the layer width:
	 * width of scanout area within the layer height: height of scanout
	 * area within the layer
	 */
	void (*set_layer_source_rectangle)(struct wl_client *client,
					   struct wl_resource *resource,
					   uint32_t layer_id,
					   int32_t x,
					   int32_t y,
					   int32_t width,
					   int32_t height);
	/**
	 * Set the destination area of a surface within a layer
	 *
	 * The destination rectangle defines the position and size of a
	 * surface on a layer. The surface will be scaled to this rectangle
	 * for rendering. If a parameter is less than 0, that value is not
	 * changed. x: horizontal start position of surface within the
	 * layer y: vertical start position of surface within the layer
	 * width : width of surface within the layer height: height of
	 * surface within the layer
	 */
	void (*set_surface_destination_rectangle)(struct wl_client *client,
						  struct wl_resource *resource,
						  uint32_t surface_id,
						  int32_t x,
						  int32_t y,
						  int32_t width,
						  int32_t height);
	/**
	 * Set the destination area of a layer within a screen
	 *
	 * The destination rectangle defines the position and size of a
	 * layer on a screen. The layer will be scaled to this rectangle
	 * for rendering. If a parameter is less than 0, that value is not
	 * changed. x: horizontal start position of layer within the screen
	 * y: vertical start position of layer within the screen width :
	 * width of surface within the screen height: height of surface
	 * within the screen
	 */
	void (*set_layer_destination_rectangle)(struct wl_client *client,
						struct wl_resource *resource,
						uint32_t layer_id,
						int32_t x,
						int32_t y,
						int32_t width,
						int32_t height);
	/**
	 * request to synchronize of a surface in ivi compositor
	 *
	 * After this request, compositor sends the properties of the
	 * surface. If sync_state argument is 0, compositor sends the
	 * properties continously. If sync_state argument is not 0,
	 * compositor stops sending the properties continously.
	 */
	void (*surface_sync)(struct wl_client *client,
			     struct wl_resource *resource,
			     uint32_t surface_id,
			     int32_t sync_state);
	/**
	 * request to synchronize of a layer in ivi compositor
	 *
	 * After this request, compositor sends the properties of the
	 * layer. If sync_state argument is 0, compositor sends the
	 * properties continously. If sync_state argument is not 0,
	 * compositor stops sending the properties continously.
	 */
	void (*layer_sync)(struct wl_client *client,
			   struct wl_resource *resource,
			   uint32_t layer_id,
			   int32_t sync_state);
	/**
	 * get a parameter of an ivi_layout_surface in ivi compositor
	 *
	 * After this request, compositor sends the requested parameter.
	 */
	void (*surface_get)(struct wl_client *client,
			    struct wl_resource *resource,
			    uint32_t surface_id,
			    int32_t param);
	/**
	 * get a parameter of an ivi_layout_layer in ivi compositor
	 *
	 * After this request, compositor sends the requested parameter.
	 */
	void (*layer_get)(struct wl_client *client,
			  struct wl_resource *resource,
			  uint32_t layer_id,
			  int32_t param);
	/**
	 * take screenshot of surface
	 *
	 * An ivi_screenshot object is created which will receive an
	 * image of the buffer currently attached to the surface with the
	 * given id. If there is no surface with such name the server will
	 * respond with an ivi_screenshot.error event.
	 */
	void (*surface_screenshot)(struct wl_client *client,
				   struct wl_resource *resource,
				   uint32_t screenshot,
				   uint32_t surface_id);
	/**
	 * request to set a type for the surface in ivi compositor
	 *
	 * After this request, compositor changes the type of the
	 * surface.
	 */
	void (*set_surface_type)(struct wl_client *client,
				 struct wl_resource *resource,
				 uint32_t surface_id,
				 int32_t type);
	/**
	 * remove all surfaces from layer render order
	 *
	 * A layer has no content assigned to itself, it is a container
	 * for surfaces. This request removes all surfaces from the layer
	 * render order.
	 */
	void (*layer_clear)(struct wl_client *client,
			    struct wl_resource *resource,
			    uint32_t layer_id);
	/**
	 * add a surface to layer render order at nearest z-position
	 *
	 * A layer has no content assigned to itself, it is a container
	 * for surfaces. This request adds a surface to the topmost
	 * position of the layer render order. The added surface will cover
	 * all other surfaces of the layer.
	 */
	void (*layer_add_surface)(struct wl_client *client,
				  struct wl_resource *resource,
				  uint32_t layer_id,
				  uint32_t surface_id);
	/**
	 * remove a surface from layer render order
	 *
	 * A layer has no content assigned to itself, it is a container
	 * for surfaces. This request removes one surfaces from the layer
	 * render order. Note: the surface is not destroyed, it is just no
	 * longer contained by the layer.
	 */
	void (*layer_remove_surface)(struct wl_client *client,
				     struct wl_resource *resource,
				     uint32_t layer_id,
				     uint32_t surface_id);
	/**
	 * create an ivi_layout_layer in ivi compositor
	 *
	 * After this request, compositor creates an ivi_layout_layer
	 */
	void (*create_layout_layer)(struct wl_client *client,
				    struct wl_resource *resource,
				    uint32_t layer_id,
				    int32_t width,
				    int32_t height);
	/**
	 * destroy an ivi_layout_layer in ivi compositor
	 *
	 * After this request, compositor destroyes an existing
	 * ivi_layout_layer.
	 */
	void (*destroy_layout_layer)(struct wl_client *client,
				     struct wl_resource *resource,
				     uint32_t layer_id);
};

#define IVI_WM_SURFACE_VISIBILITY 0
#define IVI_WM_LAYER_VISIBILITY 1
#define IVI_WM_SURFACE_OPACITY 2
#define IVI_WM_LAYER_OPACITY 3
#define IVI_WM_SURFACE_SOURCE_RECTANGLE 4
#define IVI_WM_LAYER_SOURCE_RECTANGLE 5
#define IVI_WM_SURFACE_DESTINATION_RECTANGLE 6
#define IVI_WM_LAYER_DESTINATION_RECTANGLE 7
#define IVI_WM_SURFACE_CREATED 8
#define IVI_WM_LAYER_CREATED 9
#define IVI_WM_SURFACE_DESTROYED 10
#define IVI_WM_LAYER_DESTROYED 11
#define IVI_WM_SURFACE_ERROR 12
#define IVI_WM_LAYER_ERROR 13
#define IVI_WM_SURFACE_SIZE 14
#define IVI_WM_SURFACE_STATS 15
#define IVI_WM_LAYER_SURFACE_ADDED 16

/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_VISIBILITY_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_VISIBILITY_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_OPACITY_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_OPACITY_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_SOURCE_RECTANGLE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_SOURCE_RECTANGLE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_DESTINATION_RECTANGLE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_DESTINATION_RECTANGLE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_CREATED_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_CREATED_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_DESTROYED_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_DESTROYED_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_ERROR_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_ERROR_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_SIZE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_STATS_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_SURFACE_ADDED_SINCE_VERSION 1

/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_COMMIT_CHANGES_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_CREATE_SCREEN_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SET_SURFACE_VISIBILITY_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SET_LAYER_VISIBILITY_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SET_SURFACE_OPACITY_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SET_LAYER_OPACITY_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SET_SURFACE_SOURCE_RECTANGLE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SET_LAYER_SOURCE_RECTANGLE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SET_SURFACE_DESTINATION_RECTANGLE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SET_LAYER_DESTINATION_RECTANGLE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_SYNC_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_SYNC_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_GET_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_GET_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SURFACE_SCREENSHOT_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_SET_SURFACE_TYPE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_CLEAR_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_ADD_SURFACE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_LAYER_REMOVE_SURFACE_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_CREATE_LAYOUT_LAYER_SINCE_VERSION 1
/**
 * @ingroup iface_ivi_wm
 */
#define IVI_WM_DESTROY_LAYOUT_LAYER_SINCE_VERSION 1

/**
 * @ingroup iface_ivi_wm
 * Sends an surface_visibility event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_surface_visibility(struct wl_resource *resource_, uint32_t surface_id, int32_t visibility)
{
	wl_resource_post_event(resource_, IVI_WM_SURFACE_VISIBILITY, surface_id, visibility);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an layer_visibility event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_layer_visibility(struct wl_resource *resource_, uint32_t layer_id, int32_t visibility)
{
	wl_resource_post_event(resource_, IVI_WM_LAYER_VISIBILITY, layer_id, visibility);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an surface_opacity event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_surface_opacity(struct wl_resource *resource_, uint32_t surface_id, wl_fixed_t opacity)
{
	wl_resource_post_event(resource_, IVI_WM_SURFACE_OPACITY, surface_id, opacity);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an layer_opacity event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_layer_opacity(struct wl_resource *resource_, uint32_t layer_id, wl_fixed_t opacity)
{
	wl_resource_post_event(resource_, IVI_WM_LAYER_OPACITY, layer_id, opacity);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an surface_source_rectangle event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_surface_source_rectangle(struct wl_resource *resource_, uint32_t surface_id, int32_t x, int32_t y, int32_t width, int32_t height)
{
	wl_resource_post_event(resource_, IVI_WM_SURFACE_SOURCE_RECTANGLE, surface_id, x, y, width, height);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an layer_source_rectangle event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_layer_source_rectangle(struct wl_resource *resource_, uint32_t layer_id, int32_t x, int32_t y, int32_t width, int32_t height)
{
	wl_resource_post_event(resource_, IVI_WM_LAYER_SOURCE_RECTANGLE, layer_id, x, y, width, height);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an surface_destination_rectangle event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_surface_destination_rectangle(struct wl_resource *resource_, uint32_t surface_id, int32_t x, int32_t y, int32_t width, int32_t height)
{
	wl_resource_post_event(resource_, IVI_WM_SURFACE_DESTINATION_RECTANGLE, surface_id, x, y, width, height);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an layer_destination_rectangle event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_layer_destination_rectangle(struct wl_resource *resource_, uint32_t layer_id, int32_t x, int32_t y, int32_t width, int32_t height)
{
	wl_resource_post_event(resource_, IVI_WM_LAYER_DESTINATION_RECTANGLE, layer_id, x, y, width, height);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an surface_created event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_surface_created(struct wl_resource *resource_, uint32_t surface_id)
{
	wl_resource_post_event(resource_, IVI_WM_SURFACE_CREATED, surface_id);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an layer_created event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_layer_created(struct wl_resource *resource_, uint32_t layer_id)
{
	wl_resource_post_event(resource_, IVI_WM_LAYER_CREATED, layer_id);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an surface_destroyed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_surface_destroyed(struct wl_resource *resource_, uint32_t surface_id)
{
	wl_resource_post_event(resource_, IVI_WM_SURFACE_DESTROYED, surface_id);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an layer_destroyed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_layer_destroyed(struct wl_resource *resource_, uint32_t layer_id)
{
	wl_resource_post_event(resource_, IVI_WM_LAYER_DESTROYED, layer_id);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an surface_error event to the client owning the resource.
 * @param resource_ The client's resource
 * @param object_id id of a layer or surface
 * @param error error code
 * @param message error description
 */
static inline void
ivi_wm_send_surface_error(struct wl_resource *resource_, uint32_t object_id, uint32_t error, const char *message)
{
	wl_resource_post_event(resource_, IVI_WM_SURFACE_ERROR, object_id, error, message);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an layer_error event to the client owning the resource.
 * @param resource_ The client's resource
 * @param object_id id of a layer or surface
 * @param error error code
 * @param message error description
 */
static inline void
ivi_wm_send_layer_error(struct wl_resource *resource_, uint32_t object_id, uint32_t error, const char *message)
{
	wl_resource_post_event(resource_, IVI_WM_LAYER_ERROR, object_id, error, message);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an surface_size event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_surface_size(struct wl_resource *resource_, uint32_t surface_id, int32_t width, int32_t height)
{
	wl_resource_post_event(resource_, IVI_WM_SURFACE_SIZE, surface_id, width, height);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an surface_stats event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_surface_stats(struct wl_resource *resource_, uint32_t surface_id, uint32_t frame_count, uint32_t pid)
{
	wl_resource_post_event(resource_, IVI_WM_SURFACE_STATS, surface_id, frame_count, pid);
}

/**
 * @ingroup iface_ivi_wm
 * Sends an layer_surface_added event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
ivi_wm_send_layer_surface_added(struct wl_resource *resource_, uint32_t layer_id, uint32_t surface_id)
{
	wl_resource_post_event(resource_, IVI_WM_LAYER_SURFACE_ADDED, layer_id, surface_id);
}

#ifdef  __cplusplus
}
#endif

#endif
